Skip to main content
`Ctrl`+`K`

# `skopt.sampler`.Hammersly

class skopt.sampler.Hammersly(min_skip=0, max_skip=0, primes=None)

  Creates `Hammersley` sequence samples.

  The Hammersley set is equivalent to the Halton sequence, except for one dimension is replaced with a regular grid. It is not recommended to generate a Hammersley sequence with more than 10 dimension.

  For `dim == 1` the sequence falls back to Van Der Corput sequence.

  Parameters:
    min_skip int, default=-1

      Minimum skipped seed number. When `min_skip != max_skip` and both are > -1, a random number is picked.

    max_skip int, default=-1

      Maximum skipped seed number. When `min_skip != max_skip` and both are > -1, a random number is picked.

    primes tuple, default=None

      The (non-)prime base to calculate values along each axis. If empty, growing prime values starting from 2 will be used.

  References

  T-T. Wong, W-S. Luk, and P-A. Heng, “Sampling with Hammersley and Halton Points,” Journal of Graphics Tools, vol. 2, no. 2, 1997, pp. 9 - 24.

  Methods

  `generate`(dimensions, n_samples[, random_state]) | Creates samples from Hammersly set.
  `set_params`(**params) | Set the parameters of this initial point generator.

  __init__(min_skip=0, max_skip=0, primes=None)
  generate(dimensions, n_samples, random_state=None)

    Creates samples from Hammersly set.

    Parameters:
      dimensions list, shape (n_dims,)

        List of search space dimensions. Each search dimension can be defined either as

        - a `(lower_bound, upper_bound)` tuple (for `Real` or `Integer` dimensions),

        - a `(lower_bound, upper_bound, "prior")` tuple (for `Real` dimensions),

        - as a list of categories (for `Categorical` dimensions), or

        - an instance of a `Dimension` object (`Real`, `Integer` or `Categorical`).

      n_samples int

        The order of the Hammersley sequence. Defines the number of samples.

      random_state int, RandomState instance, or None (default)

        Set random state to something other than None for reproducible results.

    Returns:
      np.array, shape=(n_dim, n_samples)

        Hammersley set.

  set_params(**params)

    Set the parameters of this initial point generator.

    Parameters:
      **params dict

        Generator parameters.

      Returns
      ——-
      self object

        Generator instance.